#include <cstdlib>
#include <time.h>
#include <cassert>
#include <queue>
#include <algorithm>
#ifndef _TRON_H
#define _TRON_H
//using namespace std;
class function
{
public:
	virtual double fun(double *w) = 0 ;
	virtual void grad(double *w, double *g) = 0 ;
	virtual void Hv(double *s, double *Hs) = 0 ;
	virtual void subHv(double *s, double *Hs) {}
	virtual void subHinvv(double *s, double *Hs, bool resample=false){};
	virtual void getInvDiagH(double *M) {};
	virtual int get_nr_variable(void) = 0 ;
	virtual ~function(void){}
	void gen_k_from_n(int k, int n, int *list){
		int top = 0;
		//clock_t start_time = clock();
		int size = n, last = k;
		for(int i=0;i<n;i++){
			long long sd = rand()%size;
			assert(sd>=0);
			if(sd < last){
				list[top++] = i;
				last--;
				if(last == 0) break;
			}
			size--;
		}
		//for(int i=0;i<k;i++) printf("%d ",list[i]);
		//printf("spend %lf time in gen_k_from_n\n", float(clock()-start_time)/CLOCKS_PER_SEC);
	}
};

class TRON
{
public:
	TRON(const function *fun_obj, double eps = 0.1, double eps_cg = 0.1, int max_iter = 1000);
	~TRON();

	void tron(double *w);
	void set_print_string(void (*i_print) (const char *buf));

private:
	int trcg(double delta, double *g, double *s, double *r, bool *reach_boundary, double *Ms);
	double norm_inf(int n, double *x);

	double eps;
	double eps_cg;
	int max_iter;
	function *fun_obj;
	void info(const char *fmt,...);
	void (*tron_print_string)(const char *buf);
};
#endif
