import os

def dataof(filename, key, x_label='time', ref_f=0, step_size=False):
  x = []
  y = []
  with open(filename) as f:
    CG = 0
    Datapass = 0
    for line in f:
      if 'iter' == line[0:4]:
          tmp = line.strip()
          tmp = tmp.split()
          dct = dict(tmp[i:i+2] for i in range(0, len(tmp),2))
          print(dct)
          if key == 'f' and float(dct['f']) < ref_f: break
          # add x by x_label
          if x_label == 'tCG': x.append(int(dct['tCG'])) 
          elif x_label == 'time': x.append(dct['time'])
          elif x_label == 'CG':
            CG += int(dct['CG'])
            x.append(CG)
          elif x_label == 'Datapass':
            Datapass += int(dct['CG'])*2
            if 'diag' in filename:
                Datapass += 1
            x.append(Datapass)
          elif x_label == 'f':
            if float(dct['f']) < ref_f: break
            x.append((float(dct['f'])-ref_f)/ref_f)
          else:
            x.append(dct[x_label])
          
          # add y by key
          if key == 'rho':
            if float(dct['act'])/float(dct['pre'])>0:
              y.append(1)
            else: y.append(-1)
          elif key == 'snorm' and 'step_size' in dct and step_size:
            y.append(float(dct[key])*float(dct['step_size']))
          elif key == 'AR':
            y.append(float(dct['act'])/float(dct['pre']))
          else: y.append(dct[key])
  return x,y

data_p_n = [
    'yahoojp 15937 160266 176203',
    'yahookr 145831 314723 460554',
    'yahookr_1e-2 1459 3146 4605',
    'rcv1_train.binary 10491 9751 20242',
    'w8a 1479 48270 49749',
    'real-sim 22238 50071 72309',
    'news20.binary 9999 9997 19996',
    'HIGGS 5829123 5170877 11000000',
    'url_combined 792145 1603985 2396130',
    'kdda 7171885 1235867 8407752',
    'kddb 16579660 2684437 19264097',
    'webspam_wc_normalized_trigram.svm 212189 137811 350000',
    'criteo.trva 11745438 34095179 45840617',
    'kdd12.svm 6658036 142981069 149639105',
    'kdd12_nf.svm 6658036 14292248 20950284',
    'australian 307 383 690',
    'australian_scale 307 383 690',
    'covtype 297711 283301 581012',
    'covtype_scale 297711 283301 581012',
    'ijcnn1 4853 45137 49990',
    'madelon 1000 1000 2000',
    'mushrooms 3916 4208 8124',
    'skin_nonskin 50859 194198 245057',
    'rcv1_test 355460 321939 677399',
    'gisette_scale 3000 3000 6000',
    'epsilon_normalized 199823 200177 400000',
    'avazu-app 1734407 12861730 14596137',
    'avazu-site 5130659 20702171 25832830',
    'a9a 7841 24720 32561',
    'webspam_wc_normalized_unigram.svm 212189 137811 350000',
]

data_mul = {}

for s in data_p_n:
  tmp = s.split()
  pos, neg, tot = map(float, tmp[1:])
  data_mul[tmp[0]] = max(min(pos, neg),1) / tot 

def get_eps(fname):
  res = None
  with open(fname) as f:
    tmp = f.readline()
    if 'eps' == tmp[0:3]:
      res = float(tmp.split()[2][:-1])
  return res

d_line = ['1e-1', '1e-2', '1e-3', '1e-4', '1e-5']
def get_fs_mul(fname, mul):
  fg = []
  with open(fname) as f:
    for line in f:
      if line[0] == 'i':
        tmp = line.split()
        dct = dict(tmp[i:i+2] for i in range(0, len(tmp),2))
        fg.append((float(dct['f']), float(dct['|g|'])))
  g0 = fg[0][1]
  res = []
  for e in d_line:
    ev = float(e)
    for i in range(len(fg)):
      if i == len(fg) - 1:
        res.append(fg[i][0])
      elif fg[i+1][1] < ev * mul * g0:
        res.append(fg[i][0])
        break
  return res

def get_fs(fname, eps, _eps=1e-5):
  mul = eps/_eps
  return get_fs_mul(fname, mul)

def get_lines(data, solver, c, dr):
  for eps in ['1e-10', '1e-07', '1e-7', '1e-06', '1e-6', '1e-05', '1e-5']:
    fname = dr + '.'.join(map(str, [data, solver, c, eps, 'log']))
    if os.path.exists(fname): break
  
  if not os.path.exists(fname): print('gg')
  mul = data_mul[data]
  return get_fs_mul(fname, mul)

def legend_label(**args):
  sol = args['solver']
  ef = args['ef']
  if ef in set(['diag_new', 'slide_parallel1']):
    if sol == 'diag_mul_no_eet': return 'Mixed'
    if sol == 'diag_parallel': return 'Parallel'
  if ef == 'diag_init':
    if sol == 'diag_no_eet': return 'Diagonal $\Delta_0^2=g^T M g$'
    if sol == 'diag_no_eet_init_ori': return 'Diagonal $\Delta_0^2=g^T g$'
    if sol == 'diag_no_eet_init_gmig': return 'Diagonal $\Delta_0^2=g^T M^{-1} g$'
  if ef == 'diag_float':
    if sol == 'origin': return 'CG-double'
    if sol == 'diag_no_eet': return 'Diagonal-double'
  if sol == 'origin_float': return 'CG-single'
  if sol == 'diag_no_eet_float': return 'Diagonal-single'
  if sol == 'diag_parallel': return 'CG or Diagonal'
  if sol == 'woodbury_sample2': return 'WS2'
  if sol == 'diag_apcn': return 'DiagApcn'
  if sol == 'woodbury_mul1': return 'Wmul1' 
  if sol == 'simp_r2': return 'SimpleTR'
  elif sol == 'simp_r4_m': return 'OldSimpleTR'
  elif sol == 'simp_r4': return 'SimpleTR'
  elif sol == 'cube_simp_r4_m':
      if ef == 'alpha': return 'Cubic+'
      else: return 'NewTR'
  elif sol == 'cube_r2': return 'Cubic'
  elif sol == 'cube_simp_r2_m': return 'NewTR_M'
  elif sol == 'cube_simp_r4_m': return 'NewTR'
  elif 'search_r4' in sol : return '+better $\\alpha^*_k$'
  elif 'search_simp_r4' in sol: 
    if ef == 'alpha':
      return '+both'
    else:
      return 'NewTR+'
  elif 'tron_simp' in sol:
    if ef == 'alpha':
      return '+new rule'
    else:
      return 'NewTR'
  elif sol == 'tron': 
    if ef == 'diag_cg_2': return 'CG'
    if ef == 'show': return '2.10'
    if ef == 'fcg':
      return 'TR'
    else:
      return 'OldTR'
  elif sol == 'tron_r2': return 'AlphaTR'
  elif sol == 'tron_r2_m': return 'AlphaTR_M'
  elif sol == 'line':
    if ef == 'line': return 'Backtrack'
    else: return 'LineSearch'
  elif sol == 'exline': return 'Exact'

  if sol == 'tron_pre_4':
      return 'BFGS4'
  if sol == 'diag_delta_preserving':
      return 'DiagDP'
  if sol == 'bfgs_total':
      return 'BFGST2'
  if sol in ['diag_mul', 'diag_mul_no_eet']:
    if ef == 'show': return 'Mixed-2'
    if ef == 'diag_mul': return 'Mixed-2'
    if ef in ['final','final_time', 'final_1', 'exp1', 'exp3']: return 'Mixed-2'
    return 'Mixed-2'
  if sol in ['diag_mul1e-1', 'diag_mul_no_eet1']:
    return 'Mixed-1'
  if sol in ['diag_mul1e-3', 'diag_mul_no_eet3']:
    return 'Mixed-3'
  if sol == 'diag_old':
      return 'diagOld'

  if sol == 'origin':
    if ef == 'show': return '2.11'
    return 'CG'
  if sol in ['diag', 'diag_no_eet']:
    return 'Diagonal'
  if sol in ['diag_mul_no_eet']:
    return 'Mixed-2'
  if sol == 'woodbury_100':
    return 'SH-100'
  if sol == 'woodbury300':
    return 'SH-300'
  if sol == 'woodbury3000' or sol == 'woodbury_3000':
    return 'SH-3000'
  if sol == 'woodbury1000' or sol == 'woodbury_1000':
    if ef == 'subhessian_rand':
      return 'SH-1000'
    return 'SH-1000'

  if sol == 'woodbury_1000-1':
    return 'SH-1000-2'
  if sol == 'woodbury_1000-2':
    return 'SH-1000-s2'
  if sol == 'woodbury_1000-3':
    return 'SH-1000-s3'
  if sol == 'woodbury':
    return 'SH-100'
  return sol

def data2name(data):
  dataname = data
  if data == 'webspam_wc_normalized_trigram.svm':
    dataname =  'webspam'
  if data == 'url_combined':
    dataname =  'url'
  if data == 'news20.binary':
    dataname = 'news20'
  if data == 'rcv1_train.binary':
    dataname = 'rcv1_train'

  return dataname

def ref_f(filename):
  #print(filename)
  f = open(filename)
  ref_v = 0
  for line in f:
    if line[0] == 'i':
      tmp = line.split()
      dct = dict(tmp[i:i+2] for i in range(0, len(tmp),2))
      ref_v = dct['f']
  return float(ref_v)

def file_name(fname, solver, c, e, dr):
  res = dr+'.'.join([fname, solver, str(c), str(e), 'log'])
  if os.path.exists(res): return res
  for e in ['1e-10', '1e-07', '1e-06', '1e-05', '1e-5']:
    res = dr+'.'.join([fname, solver, str(c), str(e), 'log'])
    print(res)
    if os.path.exists(res):
      return res
  print(fname, solver, c)
  print('QQ')
  exit(1)

def ref_file_name(c, fname, dr):
  ee = '1e-10'
  if fname == 'kdda': ee = '1e-10'
  elif fname == 'kddb': ee = '1e-10'
  res = dr+'.'.join([fname,'line',str(c), ee ,'log'])
  if not os.path.exists(res):
    res = dr + '.'.join([fname, 'cube_simp_r2_m', str(c), ee, 'log'])
  return res

def check_and_create(dr):
  if not os.path.exists(dr):
    print('create dir')
    os.system('mkdir -p {}'.format(dr))
